//=============================================================================
// HXMJ12Commando.
//=============================================================================
class HXMJ12Commando extends HXHumanMilitary;

function Bool HasTwoHandedWeapon()
{
	return False;
}

function PlayReloadBegin()
{
	TweenAnimPivot('Shoot', 0.1);
}

function PlayReload()
{
}

function PlayReloadEnd()
{
}

function PlayIdle()
{
}

function TweenToShoot(float tweentime)
{
	if (Region.Zone.bWaterZone)
		TweenAnimPivot('TreadShoot', tweentime, GetSwimPivot());
	else if (!bCrouching)
		TweenAnimPivot('Shoot2', tweentime);
}

function PlayShoot()
{
	if (Region.Zone.bWaterZone)
		PlayAnimPivot('TreadShoot', , 0, GetSwimPivot());
	else
		PlayAnimPivot('Shoot2', , 0);
}

function bool IgnoreDamageType(Name damageType)
{
	if ((damageType == 'TearGas') || (damageType == 'PoisonGas'))
		return True;
	else
		return False;
}

function float ShieldDamage(Name damageType)
{
	if (IgnoreDamageType(damageType))
		return 0.0;
	else if ((damageType == 'Burned') || (damageType == 'Flamed'))
		return 0.5;
	else if ((damageType == 'Poison') || (damageType == 'PoisonEffect'))
		return 0.5;
	else
		return Super.ShieldDamage(damageType);
}


function GotoDisabledState(name damageType, EHitLocation hitPos)
{
	if (!bCollideActors && !bBlockActors && !bBlockPlayers)
		return;
	else if (!IgnoreDamageType(damageType) && CanShowPain())
		TakeHit(hitPos);
	else
		GotoNextState();
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

defaultproperties
{
	MinHealth=0.0
	CarcassType=MJ12CommandoCarcass
	WalkingSpeed=0.296
	bCanCrouch=False
	CloseCombatMult=0.5
	InitialInventory(0)=(Inventory=Class'WeaponMJ12Commando')
	InitialInventory(1)=(Inventory=Class'Ammo762mm',Count=24)
	InitialInventory(2)=(Inventory=Class'WeaponMJ12Rocket')
	InitialInventory(3)=(Inventory=Class'AmmoRocketMini',Count=10)
	BurnPeriod=0.0
	GroundSpeed=200.0
	HealthHead=250
	HealthTorso=250
	HealthLegLeft=250
	HealthLegRight=250
	HealthArmLeft=250
	HealthArmRight=250
	Mesh=GM_ScaryTroop
	MultiSkins(0)=MJ12CommandoTex1
	MultiSkins(1)=MJ12CommandoTex1
	MultiSkins(2)=MJ12CommandoTex0
	MultiSkins(3)=MJ12CommandoTex1
	CollisionRadius=28.00
	//CollisionHeight=49.88
	CollisionHeight=45.38
	BindName="MJ12Commando"
	FamiliarName="MJ12 Commando"
	UnfamiliarName="MJ12 Commando"
	NameArticle="a "
}
