//=============================================================================
// HXNanoKeyRing
//
// NanoKeyRing object.  In order to make things easier
// on the player, when the player picks up a key it's added 
// to the list of keys stored in the keyring
//=============================================================================
class HXNanoKeyRing extends HXSkilledTool;

var localized string NoKeys;
var localized string KeysAvailableLabel;

// ----------------------------------------------------------------------------
// UpdateInfo()
// ----------------------------------------------------------------------------

simulated function bool UpdateInfo(Object winObject)
{
	local HXNanoKeyReplicationInfo NanoKeyReplicationInfo;
	local HXPersonaInfoWindow winInfo;
	//local NanoKeyInfo keyInfo;
	//local int keyCount;
	local int i;

	winInfo = HXPersonaInfoWindow(winObject);
	if (winInfo == None)
		return False;

	winInfo.SetTitle(itemName);
	winInfo.SetText(KeysAvailableLabel);
	winInfo.AddLine();

	NanoKeyReplicationInfo = HXPlayerPawn( GetPlayer() ).NanoKeyReplicationInfo;

	// mega barf! but GetPropertyText won't work on clients
	if ( NanoKeyReplicationInfo.NanoKey0 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey0 );
	if ( NanoKeyReplicationInfo.NanoKey1 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey1 );
	if ( NanoKeyReplicationInfo.NanoKey2 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey2 );
	if ( NanoKeyReplicationInfo.NanoKey3 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey3 );
	if ( NanoKeyReplicationInfo.NanoKey4 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey4 );
	if ( NanoKeyReplicationInfo.NanoKey5 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey5 );
	if ( NanoKeyReplicationInfo.NanoKey6 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey6 );
	if ( NanoKeyReplicationInfo.NanoKey7 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey7 );
	if ( NanoKeyReplicationInfo.NanoKey8 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey8 );
	if ( NanoKeyReplicationInfo.NanoKey9 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey9 );
	if ( NanoKeyReplicationInfo.NanoKey10 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey10 );
	if ( NanoKeyReplicationInfo.NanoKey11 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey11 );
	if ( NanoKeyReplicationInfo.NanoKey12 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey12 );
	if ( NanoKeyReplicationInfo.NanoKey13 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey13 );
	if ( NanoKeyReplicationInfo.NanoKey14 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey14 );
	if ( NanoKeyReplicationInfo.NanoKey15 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey15 );
	if ( NanoKeyReplicationInfo.NanoKey16 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey16 );
	if ( NanoKeyReplicationInfo.NanoKey17 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey17 );
	if ( NanoKeyReplicationInfo.NanoKey18 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey18 );
	if ( NanoKeyReplicationInfo.NanoKey19 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey19 );
	if ( NanoKeyReplicationInfo.NanoKey20 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey20 );
	if ( NanoKeyReplicationInfo.NanoKey21 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey21 );
	if ( NanoKeyReplicationInfo.NanoKey22 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey22 );
	if ( NanoKeyReplicationInfo.NanoKey23 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey23 );
	if ( NanoKeyReplicationInfo.NanoKey24 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey24 );
	if ( NanoKeyReplicationInfo.NanoKey25 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey25 );
	if ( NanoKeyReplicationInfo.NanoKey26 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey26 );
	if ( NanoKeyReplicationInfo.NanoKey27 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey27 );
	if ( NanoKeyReplicationInfo.NanoKey28 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey28 );
	if ( NanoKeyReplicationInfo.NanoKey29 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey29 );
	if ( NanoKeyReplicationInfo.NanoKey30 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey30 );
	if ( NanoKeyReplicationInfo.NanoKey31 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey31 );
	if ( NanoKeyReplicationInfo.NanoKey32 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey32 );
	if ( NanoKeyReplicationInfo.NanoKey33 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey33 );
	if ( NanoKeyReplicationInfo.NanoKey34 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey34 );
	if ( NanoKeyReplicationInfo.NanoKey35 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey35 );
	if ( NanoKeyReplicationInfo.NanoKey36 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey36 );
	if ( NanoKeyReplicationInfo.NanoKey37 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey37 );
	if ( NanoKeyReplicationInfo.NanoKey38 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey38 );
	if ( NanoKeyReplicationInfo.NanoKey39 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey39 );
	if ( NanoKeyReplicationInfo.NanoKey40 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey40 );
	if ( NanoKeyReplicationInfo.NanoKey41 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey41 );
	if ( NanoKeyReplicationInfo.NanoKey42 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey42 );
	if ( NanoKeyReplicationInfo.NanoKey43 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey43 );
	if ( NanoKeyReplicationInfo.NanoKey44 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey44 );
	if ( NanoKeyReplicationInfo.NanoKey45 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey45 );
	if ( NanoKeyReplicationInfo.NanoKey46 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey46 );
	if ( NanoKeyReplicationInfo.NanoKey47 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey47 );
	if ( NanoKeyReplicationInfo.NanoKey48 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey48 );
	if ( NanoKeyReplicationInfo.NanoKey49 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey49 );
	if ( NanoKeyReplicationInfo.NanoKey50 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey50 );
	if ( NanoKeyReplicationInfo.NanoKey51 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey51 );
	if ( NanoKeyReplicationInfo.NanoKey52 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey52 );
	if ( NanoKeyReplicationInfo.NanoKey53 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey53 );
	if ( NanoKeyReplicationInfo.NanoKey54 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey54 );
	if ( NanoKeyReplicationInfo.NanoKey55 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey55 );
	if ( NanoKeyReplicationInfo.NanoKey56 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey56 );
	if ( NanoKeyReplicationInfo.NanoKey57 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey57 );
	if ( NanoKeyReplicationInfo.NanoKey58 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey58 );
	if ( NanoKeyReplicationInfo.NanoKey59 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey59 );
	if ( NanoKeyReplicationInfo.NanoKey60 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey60 );
	if ( NanoKeyReplicationInfo.NanoKey61 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey61 );
	if ( NanoKeyReplicationInfo.NanoKey62 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey62 );
	if ( NanoKeyReplicationInfo.NanoKey63 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey63 );
	if ( NanoKeyReplicationInfo.NanoKey64 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey64 );
	if ( NanoKeyReplicationInfo.NanoKey65 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey65 );
	if ( NanoKeyReplicationInfo.NanoKey66 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey66 );
	if ( NanoKeyReplicationInfo.NanoKey67 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey67 );
	if ( NanoKeyReplicationInfo.NanoKey68 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey68 );
	if ( NanoKeyReplicationInfo.NanoKey69 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey69 );
	if ( NanoKeyReplicationInfo.NanoKey70 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey70 );
	if ( NanoKeyReplicationInfo.NanoKey71 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey71 );
	if ( NanoKeyReplicationInfo.NanoKey72 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey72 );
	if ( NanoKeyReplicationInfo.NanoKey73 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey73 );
	if ( NanoKeyReplicationInfo.NanoKey74 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey74 );
	if ( NanoKeyReplicationInfo.NanoKey75 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey75 );
	if ( NanoKeyReplicationInfo.NanoKey76 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey76 );
	if ( NanoKeyReplicationInfo.NanoKey77 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey77 );
	if ( NanoKeyReplicationInfo.NanoKey78 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey78 );
	if ( NanoKeyReplicationInfo.NanoKey79 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey79 );
	if ( NanoKeyReplicationInfo.NanoKey80 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey80 );
	if ( NanoKeyReplicationInfo.NanoKey81 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey81 );
	if ( NanoKeyReplicationInfo.NanoKey82 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey82 );
	if ( NanoKeyReplicationInfo.NanoKey83 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey83 );
	if ( NanoKeyReplicationInfo.NanoKey84 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey84 );
	if ( NanoKeyReplicationInfo.NanoKey85 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey85 );
	if ( NanoKeyReplicationInfo.NanoKey86 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey86 );
	if ( NanoKeyReplicationInfo.NanoKey87 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey87 );
	if ( NanoKeyReplicationInfo.NanoKey88 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey88 );
	if ( NanoKeyReplicationInfo.NanoKey89 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey89 );
	if ( NanoKeyReplicationInfo.NanoKey90 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey90 );
	if ( NanoKeyReplicationInfo.NanoKey91 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey91 );
	if ( NanoKeyReplicationInfo.NanoKey92 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey92 );
	if ( NanoKeyReplicationInfo.NanoKey93 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey93 );
	if ( NanoKeyReplicationInfo.NanoKey94 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey94 );
	if ( NanoKeyReplicationInfo.NanoKey95 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey95 );
	if ( NanoKeyReplicationInfo.NanoKey96 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey96 );
	if ( NanoKeyReplicationInfo.NanoKey97 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey97 );
	if ( NanoKeyReplicationInfo.NanoKey98 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey98 );
	if ( NanoKeyReplicationInfo.NanoKey99 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey99 );
	if ( NanoKeyReplicationInfo.NanoKey100 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey100 );
	if ( NanoKeyReplicationInfo.NanoKey101 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey101 );
	if ( NanoKeyReplicationInfo.NanoKey102 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey102 );
	if ( NanoKeyReplicationInfo.NanoKey103 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey103 );
	if ( NanoKeyReplicationInfo.NanoKey104 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey104 );
	if ( NanoKeyReplicationInfo.NanoKey105 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey105 );
	if ( NanoKeyReplicationInfo.NanoKey106 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey106 );
	if ( NanoKeyReplicationInfo.NanoKey107 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey107 );
	if ( NanoKeyReplicationInfo.NanoKey108 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey108 );
	if ( NanoKeyReplicationInfo.NanoKey109 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey109 );
	if ( NanoKeyReplicationInfo.NanoKey110 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey110 );
	if ( NanoKeyReplicationInfo.NanoKey111 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey111 );
	if ( NanoKeyReplicationInfo.NanoKey112 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey112 );
	if ( NanoKeyReplicationInfo.NanoKey113 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey113 );
	if ( NanoKeyReplicationInfo.NanoKey114 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey114 );
	if ( NanoKeyReplicationInfo.NanoKey115 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey115 );
	if ( NanoKeyReplicationInfo.NanoKey116 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey116 );
	if ( NanoKeyReplicationInfo.NanoKey117 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey117 );
	if ( NanoKeyReplicationInfo.NanoKey118 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey118 );
	if ( NanoKeyReplicationInfo.NanoKey119 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey119 );
	if ( NanoKeyReplicationInfo.NanoKey120 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey120 );
	if ( NanoKeyReplicationInfo.NanoKey121 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey121 );
	if ( NanoKeyReplicationInfo.NanoKey122 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey122 );
	if ( NanoKeyReplicationInfo.NanoKey123 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey123 );
	if ( NanoKeyReplicationInfo.NanoKey124 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey124 );
	if ( NanoKeyReplicationInfo.NanoKey125 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey125 );
	if ( NanoKeyReplicationInfo.NanoKey126 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey126 );
	if ( NanoKeyReplicationInfo.NanoKey127 != "" )
		winInfo.SetText( "  " $ NanoKeyReplicationInfo.NanoKey127 );

	if (NanoKeyReplicationInfo.NanoKeyCount > 0)
	{
		winInfo.AddLine();
		winInfo.SetText(Description);
	}
	else
	{
		winInfo.Clear();
		winInfo.SetTitle(itemName);
		winInfo.SetText(NoKeys);
	}

	return True;
}

// ----------------------------------------------------------------------------
// PickupFunction()
//
// Called when the object is picked up off the ground.
// ----------------------------------------------------------------------------

function PickupFunction( Pawn Other )
{
	local HXPlayerPawn OtherPlayerPawn;

	Super.PickupFunction( Other );

	if ( bDeleteMe )
		return;

	// Register ourself as the KeyRing and pin us.
	OtherPlayerPawn = HXPlayerPawn(Other);
	if ( OtherPlayerPawn!=None )
	{
		OtherPlayerPawn.HXKeyRing = Self;
		OtherPlayerPawn._AddObjectToBelt( Self, 0, true );
		OtherPlayerPawn.PinInBelt( Self );
	}
}

// ----------------------------------------------------------------------------
// GetPlayer()
// ----------------------------------------------------------------------------

simulated function DeusExPlayer GetPlayer()
{
	return DeusExPlayer(Owner);
}

// ----------------------------------------------------------------------------
// GetKeyCount()
// ----------------------------------------------------------------------------

simulated function int GetKeyCount()
{
	return HXPlayerPawn(GetPlayer()).NanoKeyReplicationInfo.NanoKeyCount;
}

function float InventoryCapsFloat( name Property, pawn Other, actor Test )
{
	// Float should have enough precission for any relevant number of Keys.
	// If it breaks down, the precise of keys won't matter anymore.
	if ( Property=='KeyCount' )
		return float(GetKeyCount());

	return 0.0;
}

// ----------------------------------------------------------------------------
// state UseIt.
// ----------------------------------------------------------------------------

state UseIt
{
	function PutDown()
	{
	}

Begin:
	PlaySound( UseSound, SLOT_None );
	PlayAnim( 'UseBegin',, 0.1 );
	FinishAnim();
	LoopAnim( 'UseLoop',, 0.1 );
	GotoState( 'StopIt' );
}

// ----------------------------------------------------------------------------
// state StopIt
// ----------------------------------------------------------------------------

state StopIt
{
	function PutDown()
	{
	}

Begin:
	PlayAnim( 'UseEnd',, 0.1 );
	GotoState( 'Idle', 'DontPlaySelect' );
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

defaultproperties
{
	NoKeys="No Nanokeys Available!"
	KeysAvailableLabel="Nanokeys Available:"
	UseSound=KeysRattling
	bDisplayableInv=False
	ItemName="Nanokey Ring"
	ItemArticle="the"
	PlayerViewOffset=(X=16.0,Y=15.0,Z=-16.0)
	PlayerViewMesh=NanoKeyRingPOV
	PickupViewMesh=NanoKeyRing
	ThirdPersonMesh=NanoKeyRing
	Icon=BeltIconNanoKeyRing
	LargeIcon=LargeIconNanoKeyRing
	LargeIconWidth=47
	LargeIconHeight=44
	Description="A nanokey ring can read and store the two-dimensional molecular patterns from different nanokeys, and then recreate those patterns on demand."
	BeltDescription="KEY RING"
	bHidden=True
	Mesh=NanoKeyRing
	CollisionRadius=5.51
	//CollisionHeight=4.69
	CollisionHeight=3.94
	Mass=10.0
	Buoyancy=5.0
	bCanDrop=False
	MsgDropNotAllowed="Your %s might come in handy later on"
}
